/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.cortesias;

import com.rjconsultores.ventaboletos.entidad.TipoCortesia;
import com.rjconsultores.ventaboletos.entidad.TipoCortesiaDescuento;
import com.rjconsultores.ventaboletos.service.TipoCortesiaDescuentoService;
import com.rjconsultores.ventaboletos.service.TipoCortesiaService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import com.rjconsultores.ventaboletos.web.utilerias.ConstraintPorcentagem;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.MyTextboxDecimal;
import java.math.BigDecimal;
import java.util.Calendar;
import java.util.List;
import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.util.Clients;
import org.zkoss.zul.Button;
import org.zkoss.zul.Combobox;
import org.zkoss.zul.Messagebox;
import org.zkoss.zul.Textbox;

/**
 *
 * @author Shiro
 */
@Controller("editarTipoCortesiaDController")
@Scope("prototype")
public class EditarTipoCortesiaDController extends MyGenericForwardComposer {

    @Autowired
    private TipoCortesiaDescuentoService tipoCortesiaDService;
    @Autowired
    private TipoCortesiaService tipoCortesiaService;
    private TipoCortesiaDescuento tipoCortesiaD;
    private MyListbox tipoCortesiaDList;
    private MyTextboxDecimal txtPorcentaje;
    private List<TipoCortesia> tipoCortesiaList;
    private Button btnApagar;
    private Combobox cmbTipoCortesiaD;
    private ConstraintPorcentagem ct;
    private static Logger log = Logger.getLogger(EditarTipoCortesiaDController.class);

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        ct = new ConstraintPorcentagem();
        tipoCortesiaList = tipoCortesiaService.obtenerTodos();

        super.doAfterCompose(comp);

        tipoCortesiaD = (TipoCortesiaDescuento) Executions.getCurrent().getArg().get("tipoCortesiaD");
        tipoCortesiaDList = (MyListbox) Executions.getCurrent().getArg().get("tipoCortesiaDList");

        if (tipoCortesiaD.getTipocortesiadescuentoId() == null) {
            btnApagar.setVisible(false);
        }

        cmbTipoCortesiaD.focus();
    }

    public void onClick$btnSalvar(Event ev) throws InterruptedException {
        txtPorcentaje.getValue();
        cmbTipoCortesiaD.getValue();

        if (txtPorcentaje.getValueDecimal().compareTo(new BigDecimal("100")) > 0) {
            Clients.wrongValue(txtPorcentaje, Labels.getLabel("MSG.Porcentaje"));
            return;
        }

        try {
            if (tipoCortesiaD.getTipoCortesia() == null) {
                Messagebox.show(
                        Labels.getLabel("editarTipoCortesiaDController.MSG.tipo"),
                        Labels.getLabel("editarTipoCortesiaDController.window.title"),
                        Messagebox.OK, Messagebox.EXCLAMATION);
            } else {
                tipoCortesiaD.setActivo(Boolean.TRUE);
                tipoCortesiaD.setFecmodif(Calendar.getInstance().getTime());
                tipoCortesiaD.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());

                Double porcDouble = Double.parseDouble(txtPorcentaje.getValue());
                BigDecimal porcentaje = BigDecimal.valueOf(porcDouble);

                if (tipoCortesiaD.getTipocortesiadescuentoId() == null) {
                    List<TipoCortesiaDescuento> lsTipoCortesiaDescuento =
                            tipoCortesiaDService.buscar(porcentaje, tipoCortesiaD.getTipoCortesia());

                    if (lsTipoCortesiaDescuento.isEmpty()) {
                        tipoCortesiaDService.suscribir(tipoCortesiaD);
                        tipoCortesiaDList.addItem(tipoCortesiaD);

                        Messagebox.show(
                                Labels.getLabel("editarTipoCortesiaDController.MSG.suscribirOK"),
                                Labels.getLabel("editarTipoCortesiaDController.window.title"),
                                Messagebox.OK, Messagebox.INFORMATION);

                        closeWindow();
                    } else {
                        Messagebox.show(
                                Labels.getLabel("MSG.Registro.Existe"),
                                Labels.getLabel("editarTipoCortesiaDController.window.title"),
                                Messagebox.OK, Messagebox.EXCLAMATION);
                    }
                } else {
                    List<TipoCortesiaDescuento> lsTipoCortesiaDescuento =
                            tipoCortesiaDService.buscar(porcentaje, tipoCortesiaD.getTipoCortesia());

                    if (lsTipoCortesiaDescuento.isEmpty()) {
                        tipoCortesiaDService.actualizacion(tipoCortesiaD);
                        tipoCortesiaDList.updateItem(tipoCortesiaD);

                        Messagebox.show(
                                Labels.getLabel("editarTipoCortesiaDController.MSG.suscribirOK"),
                                Labels.getLabel("editarTipoCortesiaDController.window.title"),
                                Messagebox.OK, Messagebox.INFORMATION);

                        closeWindow();
                    } else {
                        Messagebox.show(
                                Labels.getLabel("MSG.Registro.Existe"),
                                Labels.getLabel("editarTipoCortesiaDController.window.title"),
                                Messagebox.OK, Messagebox.EXCLAMATION);
                    }
                }
            }
        } catch (Exception ex) {
            log.error(ex);
        }
    }

    public void onClick$btnApagar(Event ev) {
        try {
            int resp = Messagebox.show(
                    Labels.getLabel("editarTipoCortesiaDController.MSG.BorrarPergunta"),
                    Labels.getLabel("editarTipoCortesiaDController.window.title"),
                    Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);

            if (resp == Messagebox.YES) {

                tipoCortesiaDService.borrar(tipoCortesiaD);

                Messagebox.show(
                        Labels.getLabel("editarTipoCortesiaDController.MSG.BorrarOK"),
                        Labels.getLabel("editarTipoCortesiaDController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);

                tipoCortesiaDList.removeItem(tipoCortesiaD);

                closeWindow();
            }
        } catch (Exception ex) {
            log.error(ex);
        }
    }

//    public void onChanging$txtPorcentaje(InputEvent ie) {
//        String novoCaracter = ie.getValue();
//        Boolean temLetraNovoAsiento = novoCaracter.matches("^[a-zA-Z]+$");
//        if (temLetraNovoAsiento) {
//            novoCaracter = novoCaracter.replace(
//                    novoCaracter.subSequence(novoCaracter.length() - 1, novoCaracter.length()), "");
//            txtPorcentaje.setValue(BigDecimal.ZERO);
//        }
//    }
    public TipoCortesiaDescuento getTipoCortesiaD() {
        return tipoCortesiaD;
    }

    public void setTipoCortesiaD(TipoCortesiaDescuento tipoCortesiaD) {
        this.tipoCortesiaD = tipoCortesiaD;
    }

    public MyListbox getTipoCortesiaDList() {
        return tipoCortesiaDList;
    }

    public void setTipoCortesiaDList(MyListbox tipoCortesiaDList) {
        this.tipoCortesiaDList = tipoCortesiaDList;
    }

    public TipoCortesiaDescuentoService getTipoCortesiaDService() {
        return tipoCortesiaDService;
    }

    public void setTipoCortesiaDService(TipoCortesiaDescuentoService tipoCortesiaDService) {
        this.tipoCortesiaDService = tipoCortesiaDService;
    }

    public List<TipoCortesia> getTipoCortesiaList() {
        return tipoCortesiaList;
    }

    public void setTipoCortesiaList(List<TipoCortesia> tipoCortesiaList) {
        this.tipoCortesiaList = tipoCortesiaList;
    }

    public TipoCortesiaService getTipoCortesiaService() {
        return tipoCortesiaService;
    }

    public void setTipoCortesiaService(TipoCortesiaService tipoCortesiaService) {
        this.tipoCortesiaService = tipoCortesiaService;
    }

    public Button getBtnApagar() {
        return btnApagar;
    }

    public void setBtnApagar(Button btnApagar) {
        this.btnApagar = btnApagar;
    }

    public Combobox getCmbTipoCortesiaD() {
        return cmbTipoCortesiaD;
    }

    public void setCmbTipoCortesiaD(Combobox cmbTipoCortesiaD) {
        this.cmbTipoCortesiaD = cmbTipoCortesiaD;
    }

    public ConstraintPorcentagem getCt() {
        return ct;
    }

    public void setCt(ConstraintPorcentagem ct) {
        this.ct = ct;
    }
}
